(cl:in-package #:org-block-language.common-lisp)

(defclass common-lisp (lang)
  ())
(register-lang-class "common-lisp"
                     (find-class 'common-lisp))

(defvar cl-readtable cl:*readtable*
  ;; There is no standard way to obtain the default readtable
  ;; so we just hope it's that.
  )

(defmethod get-readtable or ((lang common-lisp) context
                             ;; Suppose we do compute header args in &key init form; can we just say &key header-args here and rely on init-form in defgeneric?
                             &key header-args
                                  ;; for caching purposes only, as we can't compute it from lang object and context alone
                                  ;; we might add a label slot, though, and ensure lang object with that label at each block
                                  )
  (declare (ignore context header-args))
  cl-readtable)

(defmethod get-package or ((lang common-lisp) context
                           ;; Suppose we do compute header args in &key init form; can we just say &key header-args here and rely on init-form in defgeneric?
                           &key header-args
                                ;; for caching purposes only, as we can't compute it from lang object and context alone
                                ;; we might add a label slot, though, and ensure lang object with that label at each block
                                )
  (let ((specified
          (awhen (assoc :package header-args :test #'eq)
            (pop it)
            (cond
              ((null it)
               (error "~S keyword is present among header-args ~S but the value is not specified in context ~S"
                      :package header-args context))
              ((cdr it)
               (error "Multiple packages specified in header-args ~S in context ~S"
                      header-args context)))
            (car it))))
    (if specified (or (find-package specified)
                      (progn
                        (warn-in-stream-at-position (get-stream context) "Package ~S specified in Org but it does not exist; encountered"
                                                    specified)
                        (aprog1 *package*
                                (format t "Using package ~S~&" it))))
        *package*)))
